package be.ac.ulb.code.wit.deepthought;

import java.util.concurrent.Future;

import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import javax.xml.ws.AsyncHandler;
import javax.xml.ws.Response;
import javax.xml.ws.soap.Addressing;

import org.apache.cxf.feature.Features;

@WebService(name = "DeepThought")
@Addressing(enabled=true, required=true)
@Features(features = "org.apache.cxf.feature.LoggingFeature")
public interface DeepThought {

    @WebMethod(operationName = "computeAnswer")
    public Response<java.lang.String> computeAnswerAsync();

    @WebMethod(operationName = "computeAnswer")
    public Future<?> computeAnswerAsync(
        @WebParam(name = "asyncHandler", targetNamespace = "")
        AsyncHandler<java.lang.String> asyncHandler
    );

    @WebMethod
    public String computeAnswer();
    
    @WebMethod
    @Oneway
    public void computeAnswerOneWay();
}
