package be.ac.ulb.code.wit.deepthought.server;

import java.util.concurrent.Future;

import javax.annotation.Resource;
import javax.jws.WebService;
import javax.xml.ws.AsyncHandler;
import javax.xml.ws.Response;
import javax.xml.ws.WebServiceContext;
import javax.xml.ws.handler.MessageContext;
import javax.xml.ws.soap.Addressing;

import org.apache.cxf.ws.addressing.AddressingProperties;
import org.apache.cxf.ws.addressing.EndpointReferenceType;

import be.ac.ulb.code.wit.deepthought.DeepThought;
import be.ac.ulb.code.wit.deepthought.DeepThoughtConsts;

@WebService(name=DeepThoughtConsts.SERVICENAME, 
			serviceName=DeepThoughtConsts.SERVICENAME, 
			targetNamespace=DeepThoughtConsts.NS)
@Addressing
public class DeepThoughtImpl implements DeepThought {
    //Gives the message that had been sent for this query
    @Resource
    WebServiceContext webServiceContext;
    
    //Allow answering to queries asynchronously
    CallbackThread callbacker = new CallbackThread();
    
	@Override
	public String computeAnswer() {
    	//Compute the Answer to the Ultimate Question of Life, the Universe, and Everything
    	//Since we know the answer, we do not need to wait 7.5 million years
		
    	try {
    		Thread.sleep(10000); //Yet patience is a virtue
    	}
    	catch (InterruptedException e) { }
    	
    	return "42";
	}

	@Override
	public Response<String> computeAnswerAsync() {
		return null;
	}

	@Override
	public Future<?> computeAnswerAsync(AsyncHandler<String> asyncHandler) {
		return null;
	}

	private EndpointReferenceType getReplyToReference(MessageContext context) {
        AddressingProperties addressProp = (AddressingProperties) 
        		context.get(org.apache.cxf.ws.addressing.JAXWSAConstants.SERVER_ADDRESSING_PROPERTIES_INBOUND);

        return addressProp.getReplyTo();
	}
	
	@Override
	public void computeAnswerOneWay() { 
        EndpointReferenceType eprType = getReplyToReference(
        		webServiceContext.getMessageContext());
        callbacker.scheduleCallback(eprType, computeAnswer());
	}

	public void shutdown() {
		callbacker.stopProcessing();
	}
}
