package be.ac.ulb.code.wit.deepthought.soap.client;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;

import javax.xml.ws.AsyncHandler;
import javax.xml.ws.Response;
import javax.xml.ws.Service;

import be.ac.ulb.code.wit.deepthought.DeepThought;
import be.ac.ulb.code.wit.deepthought.DeepThoughtConsts;

public class AsyncServiceClient {
	
	private static DeepThought getService() throws MalformedURLException {
		Service service = Service.create(
				new URL(DeepThoughtConsts.SERVICEADDRESS + "?wsdl"),
				DeepThoughtConsts.SERVICE);
		
		return service.getPort(DeepThought.class);
	}
	
	private static Future<?> computeAnswer(DeepThought deepthought) {
		System.out.println("Computing the answer");
		
		return deepthought.computeAnswerAsync(new AsyncHandler<String>() {
			@Override
			public void handleResponse(Response<String> arg0) {
				try {
					System.out.println("The answer is " + arg0.get());
				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (ExecutionException e) {
					e.printStackTrace();
				}
			}
		});
	}
	
	public static void main(String args[]) throws MalformedURLException {
		
		//Connect to the service
		DeepThought d = getService();
		Future<?> response = computeAnswer(d);
		
		int i = 0;
		while (!response.isDone()) {
			System.out.println("Doing some work... (" + i + ")");
			++i;
			try { Thread.sleep(1000);
			} catch (InterruptedException e) { }
		} 
		
		System.out.println("Shutting down...");
	}
}
