package be.ac.ulb.code.wit.deepthought.soap.client;

import java.net.MalformedURLException;
import java.net.URL;

import javax.xml.ws.Service;

import be.ac.ulb.code.wit.deepthought.DeepThought;
import be.ac.ulb.code.wit.deepthought.DeepThoughtConsts;

public class ServiceClient {
	
	private static DeepThought getService() throws MalformedURLException {
		Service service = Service.create(
				new URL(DeepThoughtConsts.SERVICEADDRESS + "?wsdl"),
				DeepThoughtConsts.SERVICE);
		
		service.setHandlerResolver(new VersionHeaderHR());
		
		return service.getPort(DeepThought.class);
	}
	
	public static void main(String args[]) throws MalformedURLException {
		
		//Connect to the service
		DeepThought d = getService();
		String response = d.computeAnswer();
		
		System.out.println("The answer is: " + response);
		System.out.println("Shutting down...");
	}
}
