package be.ac.ulb.code.wit.deepthought.soap.client;

import java.util.ArrayList;
import java.util.List;

import javax.xml.soap.SOAPHeader;
import javax.xml.ws.handler.Handler;
import javax.xml.ws.handler.HandlerResolver;
import javax.xml.ws.handler.MessageContext;
import javax.xml.ws.handler.PortInfo;
import javax.xml.ws.handler.soap.SOAPMessageContext;

import be.ac.ulb.code.wit.deepthought.DeepThoughtConsts;

public class VersionHeaderHR implements HandlerResolver {
	String version = null;
	
	public VersionHeaderHR() { }
	
	public VersionHeaderHR(String version) {
		this.version = version;
	}
	
	Handler<SOAPMessageContext> h = new Handler<SOAPMessageContext>() {
		@Override
		public void close(MessageContext arg0) { }

		@Override
		public boolean handleFault(SOAPMessageContext arg0) { return false; }

		@Override
		public boolean handleMessage(SOAPMessageContext arg0) {
			if ((Boolean)arg0.get(MessageContext.MESSAGE_OUTBOUND_PROPERTY)) {
				//Tag outgoing messages with version 1
				try {
					if (version != null) {
						SOAPHeader header = arg0.getMessage().getSOAPHeader();
						
						if (header == null) {
							header = arg0.getMessage().getSOAPPart().getEnvelope().addHeader();
						}
						
						header.addChildElement(DeepThoughtConsts.SERVICE_VERSION)
							.setTextContent(version);
					}

					return true;
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			return false;
		}
	};

	@SuppressWarnings("rawtypes")
	@Override
	public List<Handler> getHandlerChain(PortInfo arg0) {
		List<Handler> result = new ArrayList<Handler>();
		result.add(h);
		return result;
	}
}
