package be.ac.ulb.code.wit.deepthought.soap.server;


import javax.xml.ws.Endpoint;

import org.apache.cxf.BusFactory;
import org.apache.cxf.jaxws.EndpointImpl;

import be.ac.ulb.code.wit.deepthought.DeepThought;
import be.ac.ulb.code.wit.deepthought.DeepThoughtConsts;
import be.ac.ulb.code.wit.deepthought.server.DeepThoughtDummy;
import be.ac.ulb.code.wit.deepthought.server.DeepThoughtImplV1;
import be.ac.ulb.code.wit.deepthought.server.DeepThoughtImplV2;

public class ServiceServer {
    public static void main(String args[]) throws Exception {
        System.out.println("Starting Server");
        
        DeepThought impl;
        
        impl = new DeepThoughtImplV1();
        Endpoint.publish(DeepThoughtConsts.SERVICEADDRESS_V1, impl);
        
        impl = new DeepThoughtImplV2();
        Endpoint.publish(DeepThoughtConsts.SERVICEADDRESS_V2, impl);
        
        impl = new DeepThoughtDummy();
        javax.xml.ws.Endpoint jaxwsEndpoint = 
        		Endpoint.publish(DeepThoughtConsts.SERVICEADDRESS, impl);
        EndpointImpl jaxwsEndpointImpl = (EndpointImpl)jaxwsEndpoint;
        jaxwsEndpointImpl.getServer().getEndpoint()
        	.getInInterceptors().add(new RouterInterceptor());
        
        System.out.println(String.format("Server available at %s", DeepThoughtConsts.SERVICEADDRESS));
		System.in.read();
		
		BusFactory.getDefaultBus().shutdown(true);
    }
}
